#!/usr/bin/python3

from sys import argv, stdin, exit

assert len(argv)==4, "correct usage: python3 {} input our_output contestants_output".format(argv[0])

input_tokens = open(argv[1],'r').read().split()
N = int( input_tokens[0] )
M = int( input_tokens[1] )
S =      input_tokens[2]

our_output_tokens = open(argv[2],'r').read().split()
answer_type = our_output_tokens[0]
best_answer = [ int(x) for x in our_output_tokens[1:] ]

their_output_tokens = open(argv[3],'r').read().split()

try:
    assert len(their_output_tokens)==N, "Vystupem ma byt posloupnost N celych cisel."
    try:
        their_answer = [ int(x) for x in their_output_tokens ]
    except:
        assert False, "Vystupem ma byt posloupnost N celych cisel."

    if answer_type == 'best':
        if best_answer[0] == -1:
            assert best_answer == their_answer, "Vystupem mela byt posloupnost samych -1."
        else:
            assert their_answer[0] != -1, "Reseni existuje ale nenasli jste ho."
            for x in their_answer:
                assert 0 <= x <= M, "Cisla maji byt od 0 do M."
            assert best_answer == their_answer, "Nekorektni nebo neoptimalni posloupnost."

    if answer_type == 'any':
        if best_answer[0] == -1:
            assert best_answer == their_answer, "Vystupem mela mela byt posloupnost samych -1."
        else:
            assert their_answer[0] != -1, "Reseni existuje ale nenasli jste ho."
            for x in their_answer:
                assert 0 <= x <= M, "Cisla maji byt od 0 do M."
            for n in range(N-1):
                if S[n]=='<': assert their_answer[n] < their_answer[n+1], "Nekorektni posloupnost."
                if S[n]=='>': assert their_answer[n] > their_answer[n+1], "Nekorektni posloupnost."
                if S[n]=='=': assert their_answer[n] == their_answer[n+1], "Nekorektni posloupnost."

except BaseException as error_message:
    print(error_message)
    exit(1)

print("OK")
