#include <algorithm>
#include <iostream>
#include <string>
#include <vector>
using namespace std;

inline void fix(int z, vector<int> &A, const string &nS) {
    A[z] = 0;
    if (z>0             && nS[z-1]=='<') A[z] = max( A[z], A[z-1]+1 );
    if (z<int(A.size()) && nS[z]  =='>') A[z] = max( A[z], A[z+1]+1 );
}

int main() {
    int N, M; cin >> N >> M;
    string S; cin >> S;
    vector<int> A(1,N);
    vector<int> pocet(1,1);
    string nS;
    for (char c:S) {
        if (c=='<') { A.push_back( A.back()+1 ); pocet.push_back(1); nS += c; }
        if (c=='=') ++pocet.back();
        if (c=='>') { A.push_back( A.back()-1 ); pocet.push_back(1); nS += c; }
    }
    int Z = A.size();
    for (int z=0; z<Z; ++z) fix(z,A,nS);
    for (int z=Z-1; z>=0; --z) fix(z,A,nS);
    bool fits = true;
    for (int i=0; i<Z; ++i) if (A[i]>M) fits = false;
    if (fits) {
        for (int i=0; i<Z; ++i) for (int j=0; j<pocet[i]; ++j) cout << (i+j?" ":"") << A[i];
    } else {
        for (int n=0; n<N; ++n) cout << (n?" -1":"-1");
    }
    cout << endl;
}
